﻿using EduSpider.Utility.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using VTX.FW.Attr;

namespace EduSpider.Model.Entity
{
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
	public class RB_Account
	{
		/// <summary>
		/// 唯一key
		/// </summary>
		public int UniqueId { get; set; }

		/// <summary>
		/// 对应 teacherId / stuId
		/// </summary>
		public int Id { get; set; }

		/// <summary>
		/// 登录账号
		/// </summary>
		public string Account { get; set; }

		/// <summary>
		/// 密码
		/// </summary>
		public string Password { get; set; }

		/// <summary>
		/// 类型  1老师  2学生
		/// </summary>
		public AccountTypeEnum AccountType { get; set; }

		/// <summary>
		/// 对应 老师/学生UID
		/// </summary>
		public int AccountId { get; set; }

		/// <summary>
		/// 删除状态
		/// </summary>
		public DateStateEnum Status { get; set; }

		/// <summary>
		/// 微信唯一识别码
		/// </summary>
		public string OpenId { get; set; }

		/// <summary>
		/// 微信UnionId
		/// </summary>
		public string UnionId { get; set; }

	}
}
