﻿using System;
using VTX.FW.Attr;

namespace EduSpider.Model.Entity
{
    /// <summary>
    /// 课程实体类
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Stu_HomeWork
    {
        /// <summary>
        /// 学生家庭作业主键编号
        /// </summary>
        public int stu_homework_id { get; set; }

        /// <summary>
        /// admire
        /// </summary>
        public string admire { get; set; }

        /// <summary>
        /// cancel
        /// </summary>
        public string cancel { get; set; }

        /// <summary>
        /// 正确数量
        /// </summary>
        public decimal correct { get; set; }

        /// <summary>
        /// 错误题数
        /// </summary>
        public int wrong { get; set; }

        /// <summary>
        /// 课程编号
        /// </summary>
        public int course_id { get; set; }

        /// <summary>
        /// is_cream
        /// </summary>
        public int is_cream { get; set; }

        /// <summary>
        /// emend
        /// </summary>
        public int emend { get; set; }

        /// <summary>
        /// 作业编号
        /// </summary>
        public int homework_id { get; set; }

        /// <summary>
        /// 作业分享Key
        /// </summary>
        public string homework_share_key { get; set; }

        /// <summary>
        /// is_draft
        /// </summary>
        public int is_draft { get; set; }

        /// <summary>
        /// is_reform
        /// </summary>
        public int? is_reform { get; set; }

        /// <summary>
        /// 是否补交(1-正常，2-补交）
        /// </summary>
        public int is_revised { get; set; }

        /// <summary>
        /// is_startd
        /// </summary>
        public int is_startd { get; set; }

        /// <summary>
        /// readover
        /// </summary>
        public string readover { get; set; }

        /// <summary>
        /// 提交时间
        /// </summary>
        public DateTime ref_time { get; set; }

        /// <summary>
        /// 评语
        /// </summary>
        public string comment { get; set; }

        /// <summary>
        /// reform
        /// </summary>
        public string reform { get; set; }

        /// <summary>
        /// school_uid
        /// </summary>
        public int school_uid { get; set; }

        /// <summary>
        /// 得分
        /// </summary>
        public decimal score { get; set; }

        /// <summary>
        /// 得分率
        /// </summary>
        public decimal score_p { get; set; }

        /// <summary>
        /// 评分机制
        /// </summary>
        public int score_type { get; set; }

        /// <summary>
        /// show_time
        /// </summary>
        public DateTime show_time { get; set; }

        /// <summary>
        /// 作业状态(0-未提交，1-已提交，2-已批阅)
        /// </summary>
        public int status { get; set; }

        /// <summary>
        /// 学生作业分享Key
        /// </summary>
        public string stu_homework_share_key { get; set; }

        /// <summary>
        /// 学生账号
        /// </summary>
        public string student_account { get; set; }

        /// <summary>
        /// 学生姓名
        /// </summary>
        public string student_name { get; set; }

        /// <summary>
        /// 学生编号
        /// </summary>
        public int student_uid { get; set; }

        /// <summary>
        /// 教师账号
        /// </summary>
        public string th_account { get; set; }

        /// <summary>
        /// th_cancel
        /// </summary>
        public string th_cancel { get; set; }

        /// <summary>
        /// 教师姓名
        /// </summary>
        public string th_name { get; set; }

        /// <summary>
        /// 教师数量
        /// </summary>
        public int th_num { get; set; }

        /// <summary>
        /// 教师创建时间
        /// </summary>
        public DateTime th_time { get; set; }

        /// <summary>
        /// 教师账号表编号
        /// </summary>
        public int th_uid { get; set; }

        /// <summary>
        /// 创建时间
        /// </summary>
        public DateTime add_time { get; set; }

        /// <summary>
        /// 更新时间
        /// </summary>
        public DateTime update_time { get; set; }
    }
}
