﻿using EduSpider.IRepository;
using EduSpider.Model.Entity;
using EduSpider.Repository.Base;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VTX.FW.DB.Dapper;

namespace EduSpider.Repository
{
    /// <summary>
    /// 课程仓储层
    /// </summary>
    public class CommentRepository : BaseRepository<RB_Comment>, ICommentRepository
    {
        /// <summary>
        /// 获取评语
        /// </summary>
        /// <param name="Score"></param>
        /// <returns></returns>
        public RB_Comment GetComment(decimal Score)
        {
            StringBuilder builder = new();
            builder.AppendFormat(@"
SELECT A.*
FROM RB_Comment AS A
WHERE 1=1
");
            if (Score > 0)
            {
                builder.AppendFormat(@" AND A.StartNum<{0} AND {0}<=A.EndNum ", Score);
            }
            else
            {
                builder.AppendFormat(@" AND A.StartNum<={0} AND {0}<=A.EndNum ", Score);
            }

            return base.Get<RB_Comment>(builder.ToString()).ToList().FirstOrDefault();
        }

        /// <summary>
        /// 获取系统配置评价列表
        /// </summary>
        /// <returns></returns>
        public List<RB_Comment> GetCommentListRepository()
        {
            StringBuilder builder = new();
            builder.AppendFormat(@"
SELECT A.*
FROM RB_Comment AS A
WHERE 1=1
");

            return base.Get<RB_Comment>(builder.ToString()).ToList();
        }
    }
}
